## imcode.server.document.index
Interface DocumentIndex

All Known Subinterfaces:
  DirectoryIndex

All Known Implementing Classes:
  DocumentIndexWrapper, LoggingDocumentIndex, MockDocumentIndex, PhaseQueryFixingDocumentIndex, RebuildingDirectoryIndex

    public interface DocumentIndex

Field Summary
`static java.lang.String` `FIELD__ACTIVATED_DATETIME`
`static java.lang.String` `FIELD__ALIAS`
`static java.lang.String` `FIELD__ARCHIVED_DATETIME`
`static java.lang.String` `FIELD__CATEGORY`
`static java.lang.String` `FIELD__CATEGORY_ID`
`static java.lang.String` `FIELD__CATEGORY_TYPE`
`static java.lang.String` `FIELD__CATEGORY_TYPE_ID`
`static java.lang.String` `FIELD__CHILD_ID`
`static java.lang.String` `FIELD__CREATED_DATETIME`
`static java.lang.String` `FIELD__CREATOR_ID`
`static java.lang.String` `FIELD__DOC_TYPE_ID`
`static java.lang.String` `FIELD__IMAGE_LINK_URL`
`static java.lang.String` `FIELD__KEYWORD`
`static java.lang.String` `FIELD__META_HEADLINE`
`static java.lang.String` `FIELD__META_HEADLINE_KEYWORD`
`static java.lang.String` `FIELD__META_ID`
`static java.lang.String` `FIELD__META_TEXT`
`static java.lang.String` `FIELD__MIME_TYPE`
`static java.lang.String` `FIELD__MODIFIED_DATETIME`
`static java.lang.String` `FIELD__NONSTRIPPED_TEXT`
`static java.lang.String` `FIELD__PARENT_ID`
`static java.lang.String` `FIELD__PARENT_MENU_ID`
`static java.lang.String` `FIELD__PHASE`
`static java.lang.String` `FIELD__PROPERTY_PREFIX`
`static java.lang.String` `FIELD__PUBLICATION_END_DATETIME`
`static java.lang.String` `FIELD__PUBLICATION_START_DATETIME`
`static java.lang.String` `FIELD__PUBLISHER_ID`
`static java.lang.String` `FIELD__SECTION`
`static java.lang.String` `FIELD__SECTION_ID`
`static java.lang.String` `FIELD__STATUS`
`static java.lang.String` `FIELD__TEMPLATE`
`static java.lang.String` `FIELD__TEXT`

Method Summary
`void` `indexDocument(DocumentDomainObject document)`
`void` `rebuild()`
`void` `removeDocument(DocumentDomainObject document)`
`java.util.List` `search(DocumentQuery query, UserDomainObject searchingUser)`

Field Detail

### FIELD__DOC_TYPE_ID

    static final java.lang.String FIELD__DOC_TYPE_ID

See Also:
  Constant Field Values

### FIELD__IMAGE_LINK_URL

    static final java.lang.String FIELD__IMAGE_LINK_URL

See Also:
  Constant Field Values

### FIELD__NONSTRIPPED_TEXT

    static final java.lang.String FIELD__NONSTRIPPED_TEXT

See Also:
  Constant Field Values

### FIELD__TEXT

    static final java.lang.String FIELD__TEXT

See Also:
  Constant Field Values

### FIELD__KEYWORD

    static final java.lang.String FIELD__KEYWORD

See Also:
  Constant Field Values

### FIELD__SECTION

    static final java.lang.String FIELD__SECTION

See Also:
  Constant Field Values

### FIELD__SECTION_ID

    static final java.lang.String FIELD__SECTION_ID

See Also:
  Constant Field Values

### FIELD__ACTIVATED_DATETIME

    static final java.lang.String FIELD__ACTIVATED_DATETIME

See Also:
  Constant Field Values

### FIELD__ARCHIVED_DATETIME

    static final java.lang.String FIELD__ARCHIVED_DATETIME

See Also:
  Constant Field Values

### FIELD__CATEGORY

    static final java.lang.String FIELD__CATEGORY

See Also:
  Constant Field Values

### FIELD__CATEGORY_ID

    static final java.lang.String FIELD__CATEGORY_ID

See Also:
  Constant Field Values

### FIELD__CATEGORY_TYPE

    static final java.lang.String FIELD__CATEGORY_TYPE

See Also:
  Constant Field Values

### FIELD__CATEGORY_TYPE_ID

    static final java.lang.String FIELD__CATEGORY_TYPE_ID

See Also:
  Constant Field Values

### FIELD__CREATED_DATETIME

    static final java.lang.String FIELD__CREATED_DATETIME

See Also:
  Constant Field Values

### FIELD__META_HEADLINE

    static final java.lang.String FIELD__META_HEADLINE

See Also:
  Constant Field Values

### FIELD__META_HEADLINE_KEYWORD

    static final java.lang.String FIELD__META_HEADLINE_KEYWORD

See Also:
  Constant Field Values

### FIELD__META_ID

    static final java.lang.String FIELD__META_ID

See Also:
  Constant Field Values

### FIELD__META_TEXT

    static final java.lang.String FIELD__META_TEXT

See Also:
  Constant Field Values

### FIELD__MODIFIED_DATETIME

    static final java.lang.String FIELD__MODIFIED_DATETIME

See Also:
  Constant Field Values

### FIELD__PARENT_ID

    static final java.lang.String FIELD__PARENT_ID

See Also:
  Constant Field Values

### FIELD__PARENT_MENU_ID

    static final java.lang.String FIELD__PARENT_MENU_ID

See Also:
  Constant Field Values

### FIELD__PUBLICATION_END_DATETIME

    static final java.lang.String FIELD__PUBLICATION_END_DATETIME

See Also:
  Constant Field Values

### FIELD__PUBLICATION_START_DATETIME

    static final java.lang.String FIELD__PUBLICATION_START_DATETIME

See Also:
  Constant Field Values

### FIELD__STATUS

    static final java.lang.String FIELD__STATUS

See Also:
  Constant Field Values

### FIELD__PHASE

    static final java.lang.String FIELD__PHASE

See Also:
  Constant Field Values

### FIELD__MIME_TYPE

    static final java.lang.String FIELD__MIME_TYPE

See Also:
  Constant Field Values

### FIELD__CREATOR_ID

    static final java.lang.String FIELD__CREATOR_ID

See Also:
  Constant Field Values

### FIELD__PUBLISHER_ID

    static final java.lang.String FIELD__PUBLISHER_ID

See Also:
  Constant Field Values

### FIELD__PROPERTY_PREFIX

    static final java.lang.String FIELD__PROPERTY_PREFIX

See Also:
  Constant Field Values

### FIELD__ALIAS

    static final java.lang.String FIELD__ALIAS

See Also:
  Constant Field Values

### FIELD__TEMPLATE

    static final java.lang.String FIELD__TEMPLATE

See Also:
  Constant Field Values

### FIELD__CHILD_ID

    static final java.lang.String FIELD__CHILD_ID

See Also:
  Constant Field Values

Method Detail

### indexDocument

    void indexDocument(DocumentDomainObject document)
                       throws IndexException

  Throws:
    `IndexException`

### removeDocument

    void removeDocument(DocumentDomainObject document)
                        throws IndexException

  Throws:
    `IndexException`

### search

    java.util.List search(DocumentQuery query,
                          UserDomainObject searchingUser)
                          throws IndexException

  Throws:
    `IndexException`

### rebuild

    void rebuild()
                 throws IndexException

  Throws:
    `IndexException`